//+------------------------------------------------------------------+
//|                                                        dtosc.mq4 |
//|                                                           mladen |
//+------------------------------------------------------------------+
#property copyright "mladen"
#property link      "mladenfx@gmail.com"


#property indicator_separate_window
#property indicator_buffers 4
#property indicator_color1  LimeGreen
#property indicator_color2  DarkGray
#property indicator_color3  Orange
#property indicator_color4  Gray
#property indicator_style2  STYLE_DOT
#property indicator_style4  STYLE_DOT
#property indicator_minimum -5
#property indicator_maximum 105

//
//
//
//
//

   extern string TimeFrame          = "Current time frame";
   extern int    Price1             =  0;
   extern int    RsiPeriod1         = 13;
   extern int    PeriodStoch1       =  5;
   extern int    PeriodSK1          =  3;
   extern int    PeriodSD1          =  3;
   extern int    MAMode1            =  0;
   extern double TMSmoothing1       =  5;
   extern double TMDamping1         =  5;
   extern double TMNoise1           = 30;
   extern int    Price2             = 0;
   extern int    RsiPeriod2         = 13;
   extern int    PeriodStoch2       = 15;
   extern int    PeriodSK2          =  3;
   extern int    PeriodSD2          =  3;
   extern int    MAMode2            =  0;
   extern double TMSmoothing2       =  5;
   extern double TMDamping2         =  5;
   extern double TMNoise2           = 30;
   extern bool   Interpolate        = true;
   
   extern bool   alertsOn           = true;
   extern bool   alertsOnCurrent    = true;
   extern bool   alertsMessage      = true;
   extern bool   alertsSound        = false;
   extern bool   alertsEmail        = false;
   
   extern bool   arrowsVisible      = true;
   extern string arrowsIdentifier   = "dtosc Arrows1";
   extern double arrowsDisplacement = 1.0;
   extern color  arrowsUpColor      = DeepSkyBlue;
   extern color  arrowsDnColor      = PaleVioletRed;
   extern int    arrowsUpCode       = 241;
   extern int    arrowsDownCode     = 242;
   
   
//
//
//
//
//

double SK1[];
double SK2[];
double SD1[];
double SD2[];
double StoRSI1[];
double StoRSI2[];
double trend[];
double trend1[];
double trend2[];
string shortName;
string IndicatorFileName;
int    timeFrame;
bool   returnBars;
bool   calculateValue;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   IndicatorBuffers(7);
      SetIndexBuffer(0,SK1);
      SetIndexBuffer(1,SD1);
      SetIndexBuffer(2,SK2);
      SetIndexBuffer(3,SD2);
      SetIndexBuffer(4,trend);
      SetIndexBuffer(5,StoRSI1);
      SetIndexBuffer(6,StoRSI2);

   //
   //
   //
   //
   //
   
      IndicatorFileName = WindowExpertName();
      returnBars        = (TimeFrame == "returnBars");   if (returnBars)     return(0);
      calculateValue    = (TimeFrame=="calculateValue"); if (calculateValue) return(0);
      timeFrame = stringToTimeFrame(TimeFrame);   

   //
   //
   //
   //
   //
   
   shortName = timeFrameToString(timeFrame)+" 2 x dtosc ("+RsiPeriod1+","+PeriodStoch1+","+PeriodSK1+","+PeriodSD1+")";
   IndicatorShortName(shortName);
   return(0);
}

//
//
//
//
//

int deinit()
{
   string lookFor       = arrowsIdentifier+":";
   int    lookForLength = StringLen(lookFor);
   for (int i=ObjectsTotal()-1; i>=0; i--)
   {
      string objectName = ObjectName(i);
         if (StringSubstr(objectName,0,lookForLength) == lookFor) ObjectDelete(objectName);
   }
   return(0); 
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

double rsi[][2];
double ttr[][2];
int start()
{
   int i,r,counted_bars = IndicatorCounted();
      if(counted_bars < 0) return(-1);
      if(counted_bars > 0) counted_bars--;
             int limit=MathMin(Bars-counted_bars,Bars-1);
             if (returnBars) { SK1[0] = limit; return(0); }

   //
   //
   //
   //
   //

   if (calculateValue || timeFrame == Period())
   {
      if (ArrayRange(rsi,0)!=Bars) ArrayResize(rsi,Bars);
      if (ArrayRange(ttr,0)!=Bars) ArrayResize(ttr,Bars);
      for(i=limit, r=Bars-i-1; i>=0; i--,r++)
      {
         rsi[r][0] = iRsi(iMA(NULL,0,1,0,MODE_SMA,Price1,i),RsiPeriod1,i,0); 
         rsi[r][1] = iRsi(iMA(NULL,0,1,0,MODE_SMA,Price2,i),RsiPeriod2,i,1); 
         double lo1 = rsi[r][0];
         double hi1 = rsi[r][0];
         double lo2 = rsi[r][1];
         double hi2 = rsi[r][1];
            for (int k=1; k<MathMax(PeriodStoch1,PeriodStoch2) && (r-k)>=0; k++)
            {
               if (k<PeriodStoch1) lo1 = MathMin(lo1,rsi[r-k][0]);
               if (k<PeriodStoch1) hi1 = MathMax(hi1,rsi[r-k][0]);
               if (k<PeriodStoch2) lo2 = MathMin(lo2,rsi[r-k][1]);
               if (k<PeriodStoch2) hi2 = MathMax(hi2,rsi[r-k][1]);
            }
         if (hi1!=lo1)
               StoRSI1[i] = MathMax(MathMin(iTmSmooth(100.0*(rsi[r][0] - lo1)/(hi1 - lo1),TMDamping1,TMNoise1,TMSmoothing1,i,0),100),0);
         else  StoRSI1[i] = MathMax(MathMin(iTmSmooth(0                                  ,TMDamping1,TMNoise1,TMSmoothing1,i,0),100),0);      
         if (hi2!=lo2)
               StoRSI2[i] = MathMax(MathMin(iTmSmooth(100.0*(rsi[r][1] - lo2)/(hi2 - lo2),TMDamping2,TMNoise2,TMSmoothing2,i,1),100),0);
         else  StoRSI2[i] = MathMax(MathMin(iTmSmooth(0                                  ,TMDamping2,TMNoise2,TMSmoothing2,i,1),100),0);      
      }   
      for(i=limit; i>=0; i--)
      {
          SK1[i] = iMAOnArray(StoRSI1,0,PeriodSK1,0,MAMode1,i);
          SK2[i] = iMAOnArray(StoRSI2,0,PeriodSK2,0,MAMode2,i);
      }          
      for(i=limit, r=Bars-i-1; i>=0; i--,r++)
      {
          SD1[i]    = iMAOnArray(SK1,0,PeriodSD1,0,MAMode1,i);
          SD2[i]    = iMAOnArray(SK2,0,PeriodSD2,0,MAMode2,i);
          trend[i]  = 0;
          ttr[r][0] = ttr[r-1][0];
          ttr[r][0] = ttr[r-1][1];
            if (SK1[i]>SD1[i]) ttr[r][0] =  1;
            if (SK1[i]<SD1[i]) ttr[r][0] = -1;
            if (SK2[i]>SD2[i]) ttr[r][1] =  1;
            if (SK2[i]<SD2[i]) ttr[r][1] = -1;
            if (ttr[r][0]== 1 && ttr[r-1][0]!= 1 && ttr[r][1]== 1 && ttr[r-1][1]!= 1) trend[i] =  1;
            if (ttr[r][0]==-1 && ttr[r-1][0]!=-1 && ttr[r][1]==-1 && ttr[r-1][1]!=-1) trend[i] = -1;
            manageArrow(i);
      }          
      manageAlerts();        
      return(0);      
   }
   
   //
   //
   //
   //
   //
   
   limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrame,IndicatorFileName,"returnBars",0,0)*timeFrame/Period()));
   for(i=limit; i>=0; i--)
   {
      int y = iBarShift(NULL,timeFrame,Time[i]);
         SK1[i]   = iCustom(NULL,timeFrame,IndicatorFileName,"calculateValue",Price1,RsiPeriod1,PeriodStoch1,PeriodSK1,PeriodSD1,MAMode1,TMSmoothing1,TMDamping1,TMNoise2,Price2,RsiPeriod2,PeriodStoch2,PeriodSK2,PeriodSD2,MAMode2,TMSmoothing2,TMDamping2,TMNoise2,0,y);
         SD1[i]   = iCustom(NULL,timeFrame,IndicatorFileName,"calculateValue",Price1,RsiPeriod1,PeriodStoch1,PeriodSK1,PeriodSD1,MAMode1,TMSmoothing1,TMDamping1,TMNoise2,Price2,RsiPeriod2,PeriodStoch2,PeriodSK2,PeriodSD2,MAMode2,TMSmoothing2,TMDamping2,TMNoise2,1,y);
         SK2[i]   = iCustom(NULL,timeFrame,IndicatorFileName,"calculateValue",Price1,RsiPeriod1,PeriodStoch1,PeriodSK1,PeriodSD1,MAMode1,TMSmoothing1,TMDamping1,TMNoise2,Price2,RsiPeriod2,PeriodStoch2,PeriodSK2,PeriodSD2,MAMode2,TMSmoothing2,TMDamping2,TMNoise2,2,y);
         SD2[i]   = iCustom(NULL,timeFrame,IndicatorFileName,"calculateValue",Price1,RsiPeriod1,PeriodStoch1,PeriodSK1,PeriodSD1,MAMode1,TMSmoothing1,TMDamping1,TMNoise2,Price2,RsiPeriod2,PeriodStoch2,PeriodSK2,PeriodSD2,MAMode2,TMSmoothing2,TMDamping2,TMNoise2,3,y);
         trend[i] = iCustom(NULL,timeFrame,IndicatorFileName,"calculateValue",Price1,RsiPeriod1,PeriodStoch1,PeriodSK1,PeriodSD1,MAMode1,TMSmoothing1,TMDamping1,TMNoise2,Price2,RsiPeriod2,PeriodStoch2,PeriodSK2,PeriodSD2,MAMode2,TMSmoothing2,TMDamping2,TMNoise2,4,y);
         
         manageArrow(i);
            
         //
         //
         //
         //
         //
      
         if (!Interpolate || y==iBarShift(NULL,timeFrame,Time[i-1])) continue;

         //
         //
         //
         //
         //

         datetime time = iTime(NULL,timeFrame,y);
            for(int n = 1; i+n < Bars && Time[i+n] >= time; n++) continue;	
            for(    k = 1; k < n; k++)
            {
               SK1[i+k] = SK1[i] +(SK1[i+n]-SK1[i])*k/n;
               SD1[i+k] = SD1[i] +(SD1[i+n]-SD1[i])*k/n;
               SK2[i+k] = SK2[i] +(SK2[i+n]-SK2[i])*k/n;
               SD2[i+k] = SD2[i] +(SD2[i+n]-SD2[i])*k/n;
            }               
   }               

   //
   //
   //
   //
   //
   
   manageAlerts();          
   return(0);
}

//+------------------------------------------------------------------
//|                                                                  
//+------------------------------------------------------------------
//
//
//
//
//
//

double workRsi[][6];
#define _price  0
#define _change 1
#define _changa 2

//
//
//
//

double iRsi(double price, double period, int shift, int forz=0)
{
   if (ArrayRange(workRsi,0)!=Bars) ArrayResize(workRsi,Bars);
      int    z     = forz*3; 
      int    r     = Bars-shift-1;
      double alpha = 1.0/period; 

   //
   //
   //
   //
   //
   
   workRsi[r][_price+z] = price;
         if (r<period)
            {
               int k; double sum = 0; for (k=0; k<period && (r-k-1)>=0; k++) sum += MathAbs(workRsi[r-k][z+_price]-workRsi[r-k-1][z+_price]);
                  workRsi[r][z+_change] = (workRsi[r][z+_price]-workRsi[0][z+_price])/MathMax(k,1);
                  workRsi[r][z+_changa] =                                         sum/MathMax(k,1);
            }
         else
            {
               double change = workRsi[r][z+_price]-workRsi[r-1][z+_price];
                               workRsi[r][z+_change] = workRsi[r-1][z+_change] + alpha*(        change  - workRsi[r-1][z+_change]);
                               workRsi[r][z+_changa] = workRsi[r-1][z+_changa] + alpha*(MathAbs(change) - workRsi[r-1][z+_changa]);
            }
         if (workRsi[r][z+_changa] != 0)
               return(50.0*(workRsi[r][z+_change]/workRsi[r][z+_changa]+1));
         else  return(50.0);
}





//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

void manageArrow(int i)
{
   if (arrowsVisible)
   {
      ObjectDelete(arrowsIdentifier+":"+Time[i]);
      if (trend[i]!=trend[i+1])
      {
         if (trend[i] == 1) drawArrow(i,arrowsUpColor,arrowsUpCode  ,false);
         if (trend[i] ==-1) drawArrow(i,arrowsDnColor,arrowsDownCode,true);
      }
   }
}               

//
//
//
//
//

//
//
//
//
//

void drawArrow(int i,color theColor,int theCode,bool up)
{
   string name = arrowsIdentifier+":"+Time[i];
   double gap  = iATR(NULL,0,20,i);   
   
      //
      //
      //
      //
      //
      
      ObjectCreate(name,OBJ_ARROW,0,Time[i],0);
         ObjectSet(name,OBJPROP_ARROWCODE,theCode);
         ObjectSet(name,OBJPROP_COLOR,theColor);
         if (up)
               ObjectSet(name,OBJPROP_PRICE1,High[i] + arrowsDisplacement * gap);
         else  ObjectSet(name,OBJPROP_PRICE1,Low[i]  - arrowsDisplacement * gap);
}


//+------------------------------------------------------------------
//|                                                                 
//+------------------------------------------------------------------
//
//
//
//
//

void manageAlerts()
{
   if (alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1; whichBar = iBarShift(NULL,0,iTime(NULL,timeFrame,whichBar));
      if (trend[whichBar] != trend[whichBar+1])
      {
         if (trend[whichBar]== 1) doAlert(whichBar,"both vaues crossed signal UP");
         if (trend[whichBar]==-1) doAlert(whichBar,"both vaues crossed signal DOWN");
      }         
   }
}

//
//
//
//
//

void doAlert(int forBar, string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[forBar]) {
          previousAlert  = doWhat;
          previousTime   = Time[forBar];

          //
          //
          //
          //
          //

          message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," DTOSC ",doWhat);
             if (alertsMessage) Alert(message);
             if (alertsEmail)   SendMail(StringConcatenate(Symbol()," DTOSC Alert "),message);
             if (alertsSound)   PlaySound("alert2.wav");
      }
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = StringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string StringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int char = StringGetChar(s, length);
         if((char > 96 && char < 123) || (char > 223 && char < 256))
                     s = StringSetChar(s, length, char - 32);
         else if(char > -33 && char < 0)
                     s = StringSetChar(s, length, char + 224);
   }
   return(s);
}

//+------------------------------------------------------------------
//|                                                                  
//+------------------------------------------------------------------
//
//
//
//
//

double wrkTm[][6];
#define _price 0
#define _y1    1
#define _y2    2

//
//
//
//
//

double iTmSmooth(double price, double damping, double noise, double length, int i, int forInstance)
{
   if (ArrayRange(wrkTm,0) != Bars) ArrayResize(wrkTm,Bars);
   if (length<=1) return(price);
      int r = Bars-i-1;
      forInstance *= 3;

   //
   //
   //
   //
   //

      wrkTm[r][forInstance+_price] = price;

         double y1 = wrkTm[r-1][forInstance+_y1];
         double y2 = wrkTm[r-1][forInstance+_y2];
         
         double err = (wrkTm[r][forInstance+_price]-2.0*y1+y2)/noise; 
         double drv = MathMax(MathMin((1.0/length)*err*err+(1.0/length)*MathAbs(err),0.5),0.0);
         double dmp = MathMax(MathMin((1.0/length)*MathAbs(y1-y2)/noise + damping/100.0,1.0),0.0);
         
         //
         //
         //
         //
         //
         
      double tmAvg  = y1 + noise*err*drv + (y1-y2)*(1.0-dmp);
      wrkTm[r][forInstance+_y1] = tmAvg;
      wrkTm[r][forInstance+_y2] = y1;
      return(tmAvg);
}   